#coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Windows面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://www.bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: 曹觉心 <314866873@qq.com>
# +-------------------------------------------------------------------
import os,public,json,sys
setup_path = os.getenv("BT_PANEL")
os.chdir(setup_path)
sys.path.insert(0,setup_path + "/class/")

from flask import request,redirect,g
from BTPanel import session,cache
from datetime import datetime

class dict_obj:
    def __contains__(self, key):
        return getattr(self,key,None)
    def __setitem__(self, key, value): setattr(self,key,value)
    def __getitem__(self, key): return getattr(self,key,None)
    def __delitem__(self,key): delattr(self,key)
    def __delattr__(self, key): delattr(self,key)
    def get_items(self): return self


class panelSetup:
    def init(self):
        ua = request.headers.get('User-Agent')
        if ua:
            ua = ua.lower();
            if ua.find('spider') != -1 or ua.find('bot') != -1: return redirect('https://www.baidu.com');
        
        g.version = '6.6.6'
        g.title =  public.GetConfigValue('title')
        g.uri = request.path
        if not os.path.exists('data/debug.pl'):
            g.cdn_url = public.get_cdn_url()
            if not g.cdn_url:
                g.cdn_url = '/static'
            else:
                g.cdn_url = '//' + g.cdn_url + '/win/' + g.version
        else:
            g.cdn_url = '/static'

        g.setup_path = public.GetConfigValue('setup_path')
        g.recycle_bin_open = 0
        if os.path.exists("data/recycle_bin.pl"): g.recycle_bin_open = 1
            
        public.writeFile("data/panel.version",g.version)
        #if not 'version' in session:
        session['version'] = g.version;
        session['title'] = g.title
        return None
        
        
class panelAdmin(panelSetup):
    setupPath = os.getenv("BT_SETUP")
            
    #本地请求
    def local(self):
        result = panelSetup().init()
        if result: return result
        result = self.checkLimitIp()
        if result: return result
        result = self.setSession();
        if result: return result
        result = self.checkClose();
        if result: return result
        result = self.checkWebType();
        if result: return result
        result = self.checkDomain();
        if result: return result
        result = self.checkConfig();
        #self.checkSafe();
        self.GetOS();
    
    
    #检查IP白名单
    def checkAddressWhite(self):
        token = self.GetToken();
        if not token: return redirect('/login');
        if not request.remote_addr in token['address']: return redirect('/login');
        
    
    #检查IP限制
    def checkLimitIp(self):
        if os.path.exists('data/limitip.conf'):
            iplist = public.ReadFile('data/limitip.conf')
            if iplist:
                iplist = iplist.strip();
                if not public.GetClientIp() in iplist.split(','): return redirect('/login')

    
    #设置基础Session
    def setSession(self):
  
        #print(public.readFile('config/menu.json'))
        session['menus'] = sorted(json.loads(public.readFile('config/menu.json')),key=lambda x:x['sort'])
        session['yaer'] = datetime.now().year
        session['download_url'] = 'http://download.bt.cn';
        if not 'brand' in session:
            session['brand'] = public.GetConfigValue('brand');
            session['product'] = public.GetConfigValue('product');
            session['rootPath'] = '/www'
            session['download_url'] = 'http://download.bt.cn';
            session['setupPath'] = public.GetConfigValue('setup_path');
            session['logsPath'] =  public.GetConfigValue('setup_path') + '/wwwlogs';
            session['yaer'] = datetime.now().year
    
        if not 'menu' in session:
            session['menu'] = public.GetLan('menu');
        if not 'lan' in session:
            session['lan'] = public.GetLanguage();
        if not 'home' in session:
            session['home'] = 'http://www.bt.cn';
            
    
    #检查Web服务器类型
    def checkWebType(self):

        session['webserver'] = 'iis';
        if public.get_server_status('nginx') >= 0:
            session['webserver'] = 'nginx'
        elif public.get_server_status('apache') >= 0:
            session['webserver'] = 'apache';

        if os.path.exists(self.setupPath+'/'+session['webserver']+'/version.pl'):
            session['webversion'] = public.ReadFile(self.setupPath+'/'+session['webserver']+'/version.pl').strip()
        filename = self.setupPath+'/data/phpmyadminDirName.pl'
        if os.path.exists(filename):
            session['phpmyadminDir'] = public.ReadFile(filename).strip()
    
    #检查面板是否关闭
    def checkClose(self):
        if os.path.exists('data/close.pl'):
            return redirect('/close');
        
    #检查域名绑定
    def checkDomain(self):
        try:
            api_check = True
            if not 'login' in session: 
                api_check = self.get_sk()
                if api_check: 
                    session.clear()
                    return api_check
            else:
                if session['login'] == False: 
                    session.clear()
                    return redirect('/login')
            tmp = public.GetHost()
            domain = public.ReadFile('data/domain.conf')
            if domain:
                if(tmp.strip().lower() != domain.strip().lower()): 
                    session.clear()
                    return redirect('/login')       
                
            filename = 'data/login_token.pl'
            if os.path.exists(filename):
                token = public.readFile(filename).strip()
                if 'login_token' in session:
                    if session['login_token'] != token:
                        session.clear()
                        return redirect('/login?dologin=True')
        except:
            session.clear()
            return redirect('/login')

    #获取sk
    def get_sk(self,):
        save_path = self.setupPath + '/panel/config/api.json'
        if not os.path.exists(save_path): return redirect('/login')
        api_config = json.loads(public.ReadFile(save_path))
        if not api_config['open']: return redirect('/login')
        from BTPanel import get_input
        get = get_input()
        if not 'request_token' in get or not 'request_time' in get: return redirect('/login')
        client_ip = public.GetClientIp()
        if not client_ip in api_config['limit_addr']: return public.returnJson(False,'IP校验失败,您的访问IP为['+client_ip+']')
        request_token = public.md5(get.request_time + api_config['token'])
        if get.request_token == request_token: return False
        return public.returnJson(False,'密钥校验失败')
    
    #检查系统配置
    def checkConfig(self):
        if not 'config' in session:
            session['config'] = public.M('config').where("id=?",('1',)).field('webserver,sites_path,backup_path,status,mysql_root').find();
            sa_path = 'data/sa.pl'
            if os.path.exists(sa_path):
                session['config']['mssql_sa'] = public.readFile(sa_path)
   
            if not 'email' in session['config']:
                session['config']['email'] = public.M('users').where("id=?",('1',)).getField('email');
            if not 'address' in session:
                session['address'] = public.GetLocalIp()
    
    def checkSafe(self):
        mods = ['/','/site','/ftp','/database','/plugin','/soft','/public'];
        if not os.path.exists(os.getenv("BT_SETUP") + '/data/userInfo.json'):
            if 'vip' in session: del(session.vip);
        if not request.path in mods: return True
        if 'vip' in session: return True
        
        import panelAuth
        data = panelAuth.panelAuth().get_order_status(None);
        try:
            if data['status'] == True: 
                session.vip = data
                return True
            return redirect('/vpro');
        except:pass
        return False
    
    #获取操作系统类型 
    def GetOS(self):
        if not 'server_os' in session:
            tmp = {}
            tmp['x'] = 'Windows';
            tmp['osname'] = ''

            session['server_os'] = tmp